function ts = get_active_area(mat_mask, ignore_mask, dx, dt)
    dur = size(mat_mask, 3);
    pixels = zeros(dur, 1);
    
    for i = 1:dur
        frame = mat_mask(:,:,i);
        
        % remove non-counting regions
        frame = frame .* ignore_mask;    
        
        % find active pixel countm and apply proper unit:
        active_pixels = sum(frame(:));
        fov = sum(ignore_mask(:));
        
        pixels(i) = (active_pixels / fov) * dx^2;
        
    end
    
    ts = timeseries(pixels, (1:dur) * dt, 'Name', 'Active area (um^2)');
    ts.DataInfo.Units = 'um^2';
    ts.Name = 'Active area';
end

