function fig = plot_roa_mask_active_mean(roas)
   
    % calculate mean of active Xs and Ys in the mask over time:
    t = (1:roas.ts_frames) * roas.ts_dt;
    mxs = zeros(roas.ts_frames, 1);
    mys = zeros(roas.ts_frames, 1);
    angs = zeros(roas.ts_frames, 1);
    counts = zeros(roas.ts_frames, 1);
    
    for i = 1:roas.ts_frames
        frame = roas.roa_mask(:,:,i);
        % get active xs and ys:
        [ax, ay] = ind2sub(size(frame), find(frame == 1));
        mxs(i) = mean(ax);
        mys(i) = mean(ay);
        
        counts(i) = sum(frame(:));
        
        if i > 1
            rads = atan2(mys(i)-mys(i-1), mxs(i)-mxs(i-1));
            angs(i) = rad2deg(rads);
        else
            angs(i) = nan;
        end
    end
    
    % make plot:
    fig = figure();
%     plot(mxs);
%     hold on;
%     plot(mys);
    plot(smooth(angs, 20));
end

