classdef RoiSignalCollection < begonia.analysis.TSeriesDerivative

    properties
        cycles
        channels
        imgs_ref;

        roi_array;

        channel_trace
        drift_correction
        raw_signals
        dff_signals
        
        neu_doughnut_rois
        neu_doughnut_raw_signals
        neu_doughnut_dff_signals
        neu_doughnut_outer
        
        neu_doughnuts_mask
        
        dff_signals_doughnut_subtracted
    end
    
    methods
        function obj = RoiSignalCollection(ts)
            obj@begonia.analysis.TSeriesDerivative(ts);
            
            obj.ts_name = ts.name;
            obj.ts_uuid = ts.uuid;
            obj.ts_dx = ts.dx;
            obj.ts_dy = ts.dy;
            obj.ts_zoom = ts.optical_zoom;

            
        end
        
        
        function mask = get.neu_doughnuts_mask(obj)
            if ~isempty(obj.neu_doughnut_rois)
                mask = sum(cat(3, obj.neu_doughnut_rois.mask), 3);
            else
                mask = [];
            end
        end
    end
end

