% Metadata collector for use in analysis steps and results that have a
% tseries cycle/channel as it's origin
classdef TSeriesDerivative < handle
 
    properties
        ts_name
        ts_uuid
        ts_path
        ts_class
        ts_dx
        ts_dy
        ts_dt
        ts_zoom
        ts_ch
        ts_cy
        ts_frames
        
        img_ref
    end
    
    methods
        function obj = TSeriesDerivative(ts, cy, ch)
            if nargin < 3
                ch = 1;
            end
            if nargin < 2
                cy = 1;
            end
            
            obj.ts_name = ts.name;
            obj.ts_uuid = ts.uuid;
            obj.ts_path = ts.path;
            obj.ts_class = class(ts);
            
            obj.ts_dx = ts.dx;
            obj.ts_dy = ts.dy;
            obj.ts_dt = ts.dt;
            obj.ts_zoom = ts.optical_zoom;
            obj.ts_cy = cy;
            obj.ts_ch = ch;
            obj.ts_frames = ts.frames_in_cycle;
            
            obj.img_ref = ts.get_avg_img(cy, ch);
        end
        
    end
end

