function mat_out = impose_mask_on_mat(mat, mask, global_scale)
% Works for 2d or 3d masks.
if nargin < 3
    global_scale = true;
end
assert(isequal(size(mat),size(mask)));

dim = size(mask);

overlay = false(dim);
se = strel('sphere', 2);
for i = 1:dim(3)
    overlay(:,:,i) = imdilate(mask(:,:,i), se) - mask(:,:,i);
end

I = overlay(:);
overlay = cast(overlay,class(mat));
if global_scale
    overlay = overlay .* max(mat(:));
else
    for i = 1:dim(3)
        overlay(:,:,i) = overlay(:,:,i) * max(max(mat(:,:,i)));
    end
end

mat_out = mat;
mat_out(I) = overlay(I);


end

