function tbl = var2table(data_locs,var,included_columns,skip_missing)
% This function not a method in DataLocation so that it can more easily
% cached using the memoize function.
assert(ischar(var));

if nargin < 3
    included_columns = {};
end
if nargin < 4
    skip_missing = true;
end

tbl = cell(length(data_locs),1);

begonia.util.logging.backwrite();
for i = 1:length(data_locs)
    str = sprintf('loading ''%s'' %d/%d',var,i,length(data_locs));
    begonia.util.logging.backwrite(1,str);
    
    if skip_missing
        data = data_locs(i).load_var(var,[]);
        if isempty(data)
            continue;
        end
    else
        data = data_locs(i).load_var(var);
    end
    
    if isstruct(data)
        data = struct2table(data,'AsArray',true);
    end
    if ~istable(data)
        data = table({data},'VariableNames',{var});
    end
    
    if ~isempty(included_columns)
        data = data(:,included_columns);
    end
    
    if ~ismember('uuid',data.Properties.VariableNames)
        uuid = repmat({data_locs(i).dl_unique_id},height(data),1);
        data = [table(uuid),data];
    end
    
    tbl{i} = data;
end

tbl(cellfun(@isempty,tbl)) = [];

tbl = cat(1,tbl{:});
if ~isempty(tbl)
    tbl.uuid = categorical(tbl.uuid);
end
end