function mat2avi(mat,fs,path,map)
% mat2avi creates a gif from a matrix
%
%   mat2avi(mat,fs,path)
%   mat2avi(mat,fs,path,map)
%
%   REQUIRED
%   mat             - (3d numeric) 
%                     Input 3d matrix.
%   fs              - (numeric)
%                     Frame rate
%   path            - (char)
%                     Output path. Include .avi in the path.
%   PARAMETERS
%   mat             - (256x3 double/single)
%                     Matrix of a colormap. 
%                       default : begonia.colormaps.viridis(256)
if nargin < 4
    map = begonia.colormaps.viridis(256);
end

mat = begonia.mat_functions.normalize(mat,'type','uint8');

v = VideoWriter(path,'Indexed AVI');
v.Colormap = map;
v.FrameRate = fs;
open(v);
writeVideo(v,mat);
close(v);

% for i = 1:size(mat,3)
%     im = mat(:,:,i);
%     if i == 1
%         imwrite(im,map,path,'gif','LoopCount',Inf,'DelayTime',0);
%     else
%         imwrite(im,map,path,'gif','WriteMode','append','DelayTime',0);
%     end
% end

end

