function roa_table = extract_roa_events(mat,dx,dt)
%%
begonia.util.logging.vlog(2,'Finding connected components')
CC = bwconncomp(mat,6);
%%
begonia.util.logging.vlog(2,'Gathering data of each connected component')
roa_t_start = zeros(CC.NumObjects,1);
roa_t_end = zeros(CC.NumObjects,1);
roa_t_start_idx = zeros(CC.NumObjects,1);
roa_t_end_idx = zeros(CC.NumObjects,1);
roa_vol_size = zeros(CC.NumObjects,1);
roa_xy_size = zeros(CC.NumObjects,1);
roa_center = zeros(CC.NumObjects,3);

for i = 1:CC.NumObjects
    [y,x,t] = ind2sub(CC.ImageSize,CC.PixelIdxList{i});
    
    % Calculate the max x,y roa size. 
%     xy_size = unique([x,y],'rows');
%     xy_size = size(xy_size,1);
    % This method is the same as the commented lines above, but twice as
    % fast.
    xy_size = unique(y*(CC.ImageSize(2)+1)+x);
    xy_size = length(xy_size);
    
    roa_t_start(i) = (t(1)-1) * dt;
    roa_t_end(i) = (t(end)-1) * dt + dt;
    roa_t_start_idx(i) = t(1);
    roa_t_end_idx(i) = t(end) + 1;
    roa_xy_size(i) = xy_size * dx * dx;
    roa_vol_size(i) = length(CC.PixelIdxList{i}) * dt * dx * dx;
    roa_center(i,:) = round(mean([y,x,t],1));
end
roa_table = table(roa_t_start,roa_t_end,roa_xy_size,roa_vol_size,roa_t_start_idx,roa_t_end_idx,roa_center);

end

