function mask = merged_roi_mask(roi_array,roi_group,output_size)
% Merges the x y indices of multiple rois into a single mask with
% spesificed output size. 

mask = false(output_size);

I = strcmp(roi_group,{roi_array.group});
I = find(I);
for i = I
    y = roi_array(i).y;
    x = roi_array(i).x;
    
    del = x > output_size(2) | x < 1;
    x(del) = [];
    y(del) = [];
    
    del = y > output_size(1) | y < 1;
    x(del) = [];
    y(del) = [];
    
    J = sub2ind(output_size,y,x);
    mask(J) = true;
end
end

