function mat = remove_roa_events(mat,dx,area_threshold)
%%
begonia.util.logging.vlog(2,'Finding connected components')
CC = bwconncomp(mat,6);
%%
begonia.util.logging.vlog(2,'Removing too small connected components')
for i = 1:CC.NumObjects
    [x,y,t] = ind2sub(CC.ImageSize,CC.PixelIdxList{i});
    
    t = unique(t);
    
    % Calculate the max x,y roa size. 
%     xy_size = unique([x,y],'rows');
%     xy_size = size(xy_size,1);
    % This method is the same as the commented lines above, but twice as
    % fast.
    xy_size = unique(x*(CC.ImageSize(2)+1)+y);
    xy_size = length(xy_size);
    
    roa_xy_size = xy_size * dx * dx;
    
    if roa_xy_size < area_threshold
        mat(CC.PixelIdxList{i}) = false;
    end
end

end

