function [roa_mask,img_f0,img_sigma] = roa_mask(mat,filter_half_width,threshold)
mat = single(mat);
%% Temporal filter
filter_temporal = ones(1,1,1+2*filter_half_width);
filter_temporal = filter_temporal./sum(filter_temporal(:));
filter_temporal = single(filter_temporal);

begonia.util.logging.vlog(2,'Temporal smoothing');
mat_smooth = convn(mat,filter_temporal,'same');

%% Calculate f0 image
begonia.util.logging.vlog(2,'Calculating f0 img');
mat_smooth = uint16(mat_smooth);
img_f0 = mode(mat_smooth,3);
img_f0 = single(img_f0);
clear mat_smooth;
%% Generate df/f0 video
mat = mat ./ img_f0 - 1;
%% smooth df/f0 video
begonia.util.logging.vlog(2,'Temporal smoothing');
mat_smooth = convn(mat,filter_temporal,'same');
mat = mat - mat_smooth;
%%
begonia.util.logging.vlog(2,'img_sigma');
img_sigma = std(mat,[],3);
img_sigma = img_sigma/sqrt(numel(filter_temporal));

clear mat;

roa_mask = mat_smooth > img_sigma * threshold;

begonia.util.logging.vlog(2,'Complete');
end

