function [roa_mask,img_f0,img_sigma] = roa_mask_highpass(mat,filter_half_width,threshold,filter_hp_half_width)
mat = single(mat);
%% Temporal filter
filter_temporal = ones(1,1,1+2*filter_half_width);
filter_temporal = filter_temporal./sum(filter_temporal(:));
filter_temporal = single(filter_temporal);

begonia.util.logging.vlog(2,'Temporal smoothing');
mat_smooth = convn(mat,filter_temporal,'same');

%% Calculate f0 image
begonia.util.logging.vlog(2,'Calculating f0 img');
mat_smooth = uint16(mat_smooth);
img_f0 = mode(mat_smooth,3);
img_f0 = single(img_f0);
clear mat_smooth;
%% Generate df/f0 video
mat = mat ./ img_f0 - 1;
%% High pass video
filter_highpass = ones(1,1,1+2*filter_hp_half_width);
filter_highpass = filter_highpass./sum(filter_highpass(:));
filter_highpass = single(filter_highpass);

begonia.util.logging.vlog(2,'Highpass');
mat = mat - convn(mat,filter_highpass,'same');

%% smooth df/f0 video
begonia.util.logging.vlog(2,'Temporal smoothing');
mat_smooth = convn(mat,filter_temporal,'same');
%% Generate high pass version
mat = mat - mat_smooth;
%%
begonia.util.logging.vlog(2,'img_sigma');
img_sigma = std(mat,[],3);
img_sigma = img_sigma/sqrt(numel(filter_temporal));

clear mat;

roa_mask = mat_smooth > img_sigma * threshold;

begonia.util.logging.vlog(2,'Complete');
end

