% StackH5 handles tseries saved as hdf5.
classdef TSeriesH5 < begonia.scantype.procstack.TSeriesProcessed
     
    methods
        function obj = TSeriesH5(path)
            import begonia.util.logging.*;
            import begonia.scantype.prairie.*;
            
            obj@begonia.scantype.procstack.TSeriesProcessed(path);

            % Get the files of each cycle and channel.
            assert(isfield(obj.metadata,'files'), ...
                'begonia:load:missing_struct_var', ...
                'metadata struct is missing ''files'' variable.');
            
            assert(~isempty(obj.metadata.files), ...
                'begonia:load:empty_struct_var', ...
                'metadata struct has empty files var');
            
            obj.files = cellfun(@(filename) fullfile(obj.path,filename), ...
                obj.metadata.files, 'UniformOutput',false);
            
            assert(strcmp(obj.metadata.format,'StackH5'), ...
                'begonia:load:wrong_format', ...
                'Expected a spesific hdf5 format.');
        end
        
        function mat = get_mat(self,cycle,channel)
            file = self.files{cycle,channel};
            mat = begonia.util.h5arr(file);
        end
        
        function mat = get_stack(obj, cy, ch)
            begonia.util.logging.wlog(0,'(TSeriesH5) using depricated get_stack() call instead of get_mat()')
            mat = obj.get_mat(cy, ch);
        end
        
    end
    
end

