function metadata = load_metadata(stack)
    %% Load from metadata file if it exists.
    metadata_file = fullfile(stack.path,'metadata.mat');
    assert(exist(metadata_file,'file') == 2, ...
        'begonia:load:missing_metadata', ...
        'No metadata.mat file found');

    load(metadata_file);
    assert(exist('metadata','var') == 1, ...
        'begonia:load:wrong_metadata', ...
        'metadata file found, but did not contain a metadata variable.');

    %% Load properties 
    % Load properties from the metadata which shares property names of the
    % input stack. 
    class_properties = properties(stack);
    % Exclude data_loction properties
    I = ismember(class_properties,properties('begonia.data_management.DataLocation'));
    class_properties(I) = [];
    
    fields = fieldnames(metadata);
    for i = 1:length(fields)
        field = fields{i};
        if ismember(field,class_properties)
            stack.(field) = metadata.(field);
        end
    end

end

