classdef TSeriesProxy < begonia.scantype.procstack.TSeriesProcessed
    %TSeriesProxy Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        
    end
    
    methods
        function obj = TSeriesProxy(path)
            obj = obj@begonia.scantype.procstack.TSeriesProcessed(path);
            
            % validate this is a proxy stack:
            assert(obj.has_var('proxy_api') ...
                ,'begonia:load:not_proxy' ...
                ,'Missing "proxy_api" variable.');
            
            % parse metadata:
            xml_files = begonia.path.find_files(path,'.xml',false);
            assert(~isempty(xml_files) ...
                ,'begonia:load:missing_xml' ...
                ,'Missing xml file.');
            
            xml_file = xml_files{1};
            obj.load_metadata();
        end
        
        
        function mat = get_mat(obj, cy, ch, resolver)
            if nargin < 4
                % load stack without resolver
                channel_name = begonia.scantype.proxy.ch_dirname(cy, ch);
                channel_path = fullfile(obj.path, channel_name);
                mat = begonia.scantype.proxy.GPNGReader(channel_path);
            else
                % load stack using resolver:
                src_uuid = obj.load_var('proxy_src_uuid');
                stack = resolver.get_data(src_uuid);
                %stack = begonia.stack_search.find_stacks(path);
                mat = stack.get_mat(cy, ch);
            end
        end
        
        function img = get_avg_img(obj,cycle,channel)
            import begonia.util.logging.*;
            
            file = sprintf('avg_cycle_%.3d_channel_%.2d.tif',cycle ,channel);
            file = fullfile(obj.path, file);
            if exist(file, 'file')
                img = imread(file);
                return;
            end
            
            vlog(2,'[proxystack:get_std_img] starting chunked processing');
            mat = obj.get_mat(1,1);
            img = begonia.util.chunkxyfun(@(m) mean(m,3), mat, 2, 0);
            
            
            img = uint16(img);
            begonia.util.mat2tiff(img, file);
        end
        
    end
    
    
    methods(Access = private)
        
        
    end
    
    
end

