function stackdata = convert_stack(stack, outdir, dim, average)
    for cycle = 1:stack.cycles
        for channel = 1:stack.channels
            
            % get stack for this channel in this cycle:
            mat = stack.get_stack(cycle, channel);

            w = stack.original_img_dim(1);
            h = stack.original_img_dim(2);
            outmat = repmat(mat(1,1,1), w * dim, h * dim);
            curr_fnum = 1; 
            
            
            for frame = 1:average:stack.frames_in_cycle
                [file_num, row, col, ff] = mpng.frame_pos(frame, dim);
                
                % do we need to save and change previous grid file? 
                if file_num ~= curr_fnum
                    outname = ['Cy_' num2str(cycle) '_ch_' num2str(channel) ...
                        '_grid_' num2str(file_num) '.png'];
                    outpath = fullfile(outdir, outname);
                    imwrite(outmat, outpath);
                    curr_fnum = file_num;
                    outmat = repmat(mat(1,1,1), w * dim, h * dim);
                end
                
                % put current frame on grid:
                frame_mat = mat(:,:,frame:(frame + (average - 1)));
                frame_mat = mean(frame_mat, 3);
                
                x = 1 + ((col - 1) * w);
                y = 1 + ((row - 1) * h);
                outmat(x:(x+w-1),y:(y+h-1)) = frame_mat;
                
            end
        end
    end

end

