function stacks = find_tseries(dir_in,varargin)
if nargin == 0
    dir_in = uigetdir();
end

p = inputParser;
p.addRequired('dir_in',...
    @(x) validateattributes(x,{'char'},{'nonempty'}));
p.addParameter('show_waitbar',false, ...
    @(x) validateattributes(x,{'logical'},{}));
p.addParameter('ignore_str','', ...
    @(x) validateattributes(x,{'char'},{}));
p.parse(dir_in,varargin{:});
begonia.util.dump_inputParser_vars_to_caller_workspace(p);

stack_classes = {...
    @begonia.scantype.h5.TSeriesH5, ...
    @begonia.scantype.prairie.TSeriesPrairie, ...
    @begonia.scantype.proxy.TSeriesProxy};

begonia.util.logging.vlog(1,'Looking for tseries');
stacks = begonia.scantype.find_by_class(dir_in,stack_classes,...
    'show_waitbar',show_waitbar,...
    'ignore_str',ignore_str);

end

