function channel_traces = read(stack)

str = sprintf('Creating channel traces : %s',stack.path);
begonia.util.logging.vlog(1,str);

traces = [];

for i = 1:stack.channels
    mat = stack.get_mat(1,i);
    dim = size(mat);
    
    mat = mat(:,:,:);
    tmp = sum(sum(mat,1),2)/dim(1)/dim(2);
    tmp = reshape(tmp,[],1);
    traces = cat(2,traces,tmp);
end

t = (0:(size(traces,1)-1))*stack.dt;
t = t';
channel_traces = timeseries(traces,t,'Name','channel_traces');
assert(~isnan(channel_traces.TimeInfo.Increment));

end

