function f0 = read(stack, cy, ch)
    import begonia.util.logging.*;

    tic;
    if nargin < 2
        cy = 1;
        ch = 1;
    end

    sigma_dx = 1;
    sigma_dt = 0.1/stack.dt;

    win_dx = begonia.util.gausswin(sigma_dx);
    win_dt = begonia.util.gausswin(sigma_dt);
    win_dt = reshape(win_dt,1,1,[]);

    filter = win_dx*win_dx';
    filter = repmat(filter,1,1,length(win_dt));
    filter = filter.*win_dt;
    filter = filter/sum(filter(:));
    filter = single(filter);

    vlog(1, 'Loading entrie matrix');
    mat = stack.get_mat(cy,ch);
    mat = single(mat(:,:,:));
    
    vlog(1, 'Applying filter');
    mat = convn(mat,filter,'same');
    
    vlog(1, 'Downsampling')
    mat_down = mat(:,:,1:ceil(sigma_dt):end);
    mat_down = uint16(mat_down);
    
    vlog(1, 'Running mode')
    f0 = mode(mat_down,3);
    f0 = single(f0);
    
    toc;
end

