function plot_overlay(stack,t_start,t_end)
global BEGONIA_VERBOSE;
%% Limits
t_start = round(t_start/stack.dt) + 1;
t_end = round(t_end/stack.dt) + 1;

%% Load drift correction.
drift_correction_trace = stack.load_var('drift_correction_trace');
drift_correction_trace = reshape(drift_correction_trace,1,1,[]);
drift_correction_trace = single(drift_correction_trace);

mat = stack.get_stack(1,1);
mat = mat(:,:,t_start:t_end);
mat = single(mat);
mat = mat .* drift_correction_trace(t_start:t_end);

%%
fprintf('gaussian smoothing.\n');
tic

sigma_dx = 1;
sigma_dt = 0.1/stack.dt;

win_dx = begonia.util.gausswin(sigma_dx);
win_dt = begonia.util.gausswin(sigma_dt);
win_dt = reshape(win_dt,1,1,[]);

filter = win_dx*win_dx';
filter = repmat(filter,1,1,length(win_dt));
filter = filter.*win_dt;
filter = filter/sum(filter(:));
filter = single(filter);

mat = convn(mat,filter,'same');

toc
%% ROA
tic
roa_ignore_mask = stack.load_var('roa_ignore_mask');

roa_mask = stack.load_var('roa_mask');

roa_mask = roa_mask(:,:,t_start:t_end);
roa_mask = roa_mask .* roa_ignore_mask;

size_thresh = 5/stack.dx/stack.dx;
roa_mask = begonia.binary_mat_functions.filter_by_size_2d(roa_mask,size_thresh);
time_thresh = 1/stack.dt;
roa_mask = begonia.binary_mat_functions.filter_by_time(roa_mask,time_thresh);
toc
%% Merge
tic
mat = begonia.binary_mat_functions.impose_mask_on_mat(mat,roa_mask);

img_f0 = stack.load_var('img_f0');
lim = [0,max(img_f0(:))];
toc

begonia.util.matview(mat,lim);

figure
imagesc(img_f0);
begonia.util.plot_mask_overlay(~roa_ignore_mask,[1,0,0],0.5);

% figure
% imshow(~roa_ignore_mask);

end

