function roa_activity_trace = read(tseries)

assert(length(tseries) == 1);

begonia.util.logging.vlog(2,'Loading roa mask');
roa_mask        = tseries.load_var('roa_mask');

roa_ignore_mask = false(size(roa_mask,1),size(roa_mask,2));
roa_ignore_mask = tseries.load_var('roa_ignore_mask',roa_ignore_mask);

edge_ignore_width = 15;
roa_ignore_mask(1:edge_ignore_width,:) = true;
roa_ignore_mask(end-edge_ignore_width:end,:) = true;
roa_ignore_mask(:,1:edge_ignore_width) = true;
roa_ignore_mask(:,end-edge_ignore_width:end) = true;

begonia.util.logging.vlog(2,'Ignoring parts of the roa mask');
roa_mask = roa_mask & ~roa_ignore_mask;

begonia.util.logging.vlog(2,'Calculating the activity trace');
valid_area = sum(~roa_ignore_mask(:));

roa_activity_trace = roa_mask;
roa_activity_trace = sum(roa_activity_trace,1);
roa_activity_trace = sum(roa_activity_trace,2);
roa_activity_trace = squeeze(roa_activity_trace);
roa_activity_trace = roa_activity_trace./valid_area;

begonia.util.logging.vlog(2,'Complete');

end
