function ignore_mask = calculate_ignore_mask(img_f0,dx)
begonia.util.logging.vlog(2,'Calculating the ignore mask');

% Find a cutoff for areas in the image that are too dim to find ROAs.
vec = img_f0(:);
vec(vec < 100) = [];
cutoff = mode(floor(vec)) * 0.7;
ignore_mask = img_f0 < cutoff;

% Enlarge the bad parts by 1 um. 
r = round(1/dx);
se = strel('sphere',r);
ignore_mask = imdilate(ignore_mask,se);

% Make it so 'true' represents the good parts. 
ignore_mask = ~ignore_mask;

% Ignore some pixels around the edges
c = 6;
ignore_mask(1:c,:) = false;
ignore_mask(end-c:end,:) = false;
ignore_mask(:,1:c) = false;
ignore_mask(:,end-c:end) = false;
end
