function roa_table = find_roa(mat,ignore_mask,dx,dt)
%%
% begonia.util.logging.vlog(2,'Applying ignore mask')
% mat = mat & ignore_mask;
%%
begonia.util.logging.vlog(2,'Finding connected components')
CC = bwconncomp(mat,6);
%%
begonia.util.logging.vlog(2,'Gathering data of each connected component')
roa_t_start = zeros(CC.NumObjects,1);
roa_t_end = zeros(CC.NumObjects,1);
roa_vol_size = zeros(CC.NumObjects,1);
roa_xy_size = zeros(CC.NumObjects,1);

for i = 1:CC.NumObjects
    [x,y,t] = ind2sub(CC.ImageSize,CC.PixelIdxList{i});
    
    t = unique(t);
    
    % Calculate the max x,y roa size. 
%     xy_size = unique([x,y],'rows');
%     xy_size = size(xy_size,1);
    % This method is the same as the commented lines above, but twice as
    % fast.
    xy_size = unique(x*(CC.ImageSize(2)+1)+y);
    xy_size = length(xy_size);
    
    roa_t_start(i) = t(1) * dt;
    roa_t_end(i) = t(end) * dt;
    roa_xy_size(i) = xy_size * dx * dx;
    roa_vol_size(i) = length(CC.PixelIdxList{i}) * dt * dx * dx;
end

roa_table = table(roa_t_start,roa_t_end,roa_xy_size,roa_vol_size);
end

