function aligned_stacks = align_stacks(stacks, dirs_out, conf)
warning('aligned_stacks movied to begonia.tseries_operations.align_stacks. Redirecting ...')
aligned_stacks = begonia.tseries_operations.align_stacks(stacks,dirs_out,conf);
%     import begonia.util.logging.*;
%     tic;
%     tic_handle = tic();
%     % align_stacks aligns the input stacks using normcorre. 
%     %
%     %   aligned_stacks = align_stacks(stacks,dirs_out,rigid)
%     %
%     %   stacks      - (array of begonia.stack.Stack) Stacks to be aligned. 
%     %   dirs_out    - (cell of char) Array of output directories for each
%     %                 stack, must be equal length as stacks. 
%     %   rigid       - (logical, default:false) Use normcorre rigid align.
%     %
%     %   RETURNED
%     %   aligned_stacks          - (begonia.stack.Stack) 
%     %                               Aligned stacks. Empty if not found.
%     if ischar(dirs_out)
%         dirs_out = {dirs_out};
%     end
%     
%     if nargin < 3
%         % base dimentions on first stack: 
%         conf = begonia.stack_operations.AlignmentSettings(stacks(1));
%     else
%         if ~isa(conf, 'begonia.stack_operations.AlignmentSettings')
% 
%             warning(['New API: third imput format of align_stacks should now be an ' ... 
%                 'AlignmentSettings object. Attempting backwards compatibility fix']);
%             old_rigid = conf;
%             conf = begonia.stack_operations.AlignmentSettings(stacks(1));
%             conf.rigid = old_rigid;
%         end
%     end
% 
%     assert(length(stacks) == length(dirs_out),'Each stack must have a seperate output folder.');
% 
%     if isa(stacks, 'begonia.scantype.TSeries')
%         vlog(2, '(align_stacks) Using new API');
%         aligned_stacks = begonia.scantype.h5.TSeriesH5.empty(0);
%     else
%         vlog(2, '(align_stacks) Using old API');
%         aligned_stacks = begonia.stack.Stack.empty(0);
%     end
% 
%     tic
%     for i = 1:length(stacks)
%         stack = stacks(i);
%         if ~contains(stack.type,'TSeries')
%             continue
%         end
%             
%         vlog(1, sprintf('Starting alignment of \n\t%s\n',stack.path));
%         % Delete previous folders. 
%         if exist(dirs_out{i},'dir')
%             rmdir(dirs_out{i},'s');
%         end
% 
%         % Output filenames.
%         output_files = cell(stack.cycles,stack.channels);
%         for cycle = 1:stack.cycles
%             for channel = 1:stack.channels
%                 output_files{cycle,channel} = ...
%                     sprintf('%s_cycle_%.3d_ch%.2d.h5', ...
%                     stack.name,cycle,channel);
%             end
%         end
% 
%         % Alignment
%         for cycle = 1:stack.cycles
%             alignment_channel = conf.channel;
% 
%             % Load stack.
%             vlog(1, '(align_stacks) Loading matrix');
%             if isa(stack, 'begonia.scantype.TSeries')
%                 mat = stack.get_mat(cycle,alignment_channel);   % new API
%             else
%                 mat = stack.get_stack(cycle,alignment_channel);
%             end
%             % These stacks tend to be lazy and not actually matlab matricies.
%             mat = mat(:,:,:);
%             % Align
%             vlog(1, '(align_stacks) Aligning (NoRMCoRRE)');
%             [mat, shifts, template, conf.nc_params] = normcorre_batch(mat, conf.nc_params);
%             mat = uint16(mat);
%             % Save as tiff.
%             % Get the channel number from the channel name.
%             channel_num = regexp(stack.channel_names{alignment_channel},'\d*','Match');
%             channel_num = str2num(channel_num{1});
%             path = fullfile(dirs_out{i},output_files{cycle,alignment_channel});
%             begonia.path.make_dirs(path);
%             % Save as hdf5.
%             vlog(1, '(align_stacks) Saving matrix');
%             mat_lazy = begonia.util.h5arr(path,size(mat),'uint16');
%             mat_lazy(:,:,:) = mat;
% 
%             % Shift and save the other channels.
%             channels = 1:stack.channels;
%             channels(alignment_channel) = [];
%             for channel = channels
%                 vlog(1, '(align_stacks) Loading matrix');
%                 %mat = stack.get_stack(cycle,channel);
%                 
%                 if isa(stack, 'begonia.scantype.TSeries')
%                     mat = stack.get_mat(cycle,channel);   % new API
%                 else
%                     mat = stack.get_stack(cycle,channel);
%                 end
%                 
%                 mat = mat(:);
%                 vlog(1, '(align_stacks) Applying shifts');
%                 mat = apply_shifts(mat,shifts,conf.nc_params);
% 
%                 path = fullfile(dirs_out{i},output_files{cycle, channel});
%                 begonia.path.make_dirs(path);
%                 % Save as hdf5.
%                 vlog(1, '(align_stacks) Saving matrix');
%                 mat_lazy = begonia.util.h5arr(path,size(mat),'uint16');
%                 mat_lazy(:,:,:) = mat;
%             end
%         end
% 
%         % save metadata:
%         vlog(1, 'Saving metadata');
%         if conf.rigid
%             processing_state = 'normcorre_aligned_rigid';
%         else
%             processing_state = 'normcorre_aligned_nonrigid';
%         end
% 
%         begonia.scantype.procstack.save_default_metadata(...
%             stack ...
%             , dirs_out{i} ...
%             , 'StackH5' ...
%             , 'processing_state', processing_state ...
%             , 'files', output_files);
% 
%         % Copy over the xml file
%         vlog(1, 'Saving copy of first XML file');
%         xml_files = begonia.path.find_files(stack.path,'.xml');
%         [~,xml_filename,~] = fileparts(xml_files{1});
%         xml_new = fullfile(dirs_out{i},[xml_filename,'.xml']);
%         copyfile(xml_files{1},xml_new);
% 
%         % Get the new stack and create other images.
%         vlog(1, 'Creating reference images');
%         if isa(stack, 'begonia.scantype.TSeries')
%             stack_out = begonia.scantype.h5.TSeriesH5(dirs_out{i}); % new API
%         else
%             stack_out = begonia.stack.StackH5(dirs_out{i});
%         end
% 
%         stack_out.create_additional_images();
%         aligned_stacks(end+1) = stack_out;
%     end
%     vlog(2, ['(align_stacks) Done in ' num2str(toc(tic_handle)) 's']);

end

