function tbl_out = grpstats(varargin)
p = inputParser;
p.addRequired('tbl', ...
    @(x) validateattributes(x,{'table'},{}));
p.addRequired('groups');
p.addOptional('data_vars',[], ...
    @(x) validateattributes(x,{'char','cell'},{}));
p.addOptional('func',[], ...
    @(x) validateattributes(x,{'function_handle'},{}));
p.parse(varargin{:});
begonia.util.dump_inputParser_vars_to_caller_workspace(p);

if isempty(data_vars)
    var_names = tbl.Properties.VariableNames;
    I = false(length(var_names),1);
    for i = 1:length(var_names)
        I(i) = isnumeric(tbl.(var_names{i}));
    end
    data_vars = var_names(I);
end

if ischar(groups)
    groups = {groups};
end
if ischar(data_vars)
    data_vars = {data_vars};
end

if isempty(func)
    func = @(x)mean(x,1);
end

[G,tbl_out] = findgroups(tbl(:,groups));

tbl_out.N = splitapply(@length,tbl.(data_vars{1}),G);
for i = 1:length(data_vars)
    tbl_out.(data_vars{i}) = splitapply(func,tbl.(data_vars{i}),G);
end

end

