classdef AlignmentSettings < handle
    
    properties
        channel = 1;
        rigid = true;
        
        d1
        d2
        bin_width = 50;
        grid_size = [128,128];
        overlap_pre = 32;
        overlap_post = 32;
        init_batch = 200;
        max_shift = 20;
        correct_bidir = false;
        use_parallel = false;
        
        nc_params
    end
    
    methods
        function obj = AlignmentSettings(stack)
            if nargin < 1
                obj.d1 = 512;
                obj.d2 = 512;
            else
                obj.d1 = stack.original_img_dim(1);
                obj.d2 = stack.original_img_dim(2);
            end
        end
        
        function options = get.nc_params(obj)
            % from Daniel's original code:
            if obj.rigid
                options = NoRMCorreSetParms(...
                    'd1', obj.d1 ...
                    ,'d2', obj.d2 ...
                    , 'bin_width', obj.bin_width ...
                    , 'max_shift', obj.max_shift ...
                    , 'init_batch', obj.init_batch ...
                    , 'correct_bidir', obj.correct_bidir ...
                    , 'use_parallel', obj.use_parallel);
                
            else
                options = NoRMCorreSetParms(...
                    'd1', obj.d1 ...
                    , 'd2', obj.d2 ...
                    , 'bin_width', obj.bin_width ...
                    , 'grid_size', obj.grid_size ...
                    , 'overlap_pre', obj.overlap_pre ...
                    , 'overlap_post', obj.overlap_post ...
                    , 'init_batch', obj.init_batch ...
                    , 'max_shift', obj.max_shift ...
                    , 'correct_bidir', obj.correct_bidir ...
                    , 'use_parallel', obj.use_parallel);
            end
        end
    end
end

