function create_movie_tiff(stack,channel,cycle,window,output_dir)
assert(length(stack) == 1);
if nargin < 2
    channel = 1;
end
if nargin < 3
    cycle = 1;
end
if nargin < 4
    window = 10;
end
if nargin < 5
    output_dir = stack.path;
else
    begonia.path.make_dirs(output_dir);
end

assert(window >= 1)

if channel > stack.channels
    return;
end
if cycle > stack.cycles
    return;
end

% Movie parameters
map = begonia.colormaps.viridis;
fps = 30;

filename = sprintf('%s_cycle_%.3d_ch%.2d_short_video.tiff',stack.name,cycle,channel);
path = fullfile(output_dir,filename);

begonia.util.logging.vlog(1,sprintf('Starting creation of %s',filename));

%% Load
begonia.util.logging.vlog(1,'Load mat');
mat = stack.get_mat(cycle,channel);

% The mat is usually lazy, index it to get a real matlab matrix. 
mat = mat(:,:,:);

% Average window frames together
begonia.util.logging.vlog(1,'Averaging frames');
dim = size(mat);
I = 1:window:dim(3);
I(end) = [];
if isempty(I); error('Not enough frames?'); end
mat_new = zeros(dim(1),dim(2),length(I),class(mat));
for i = 1:length(I)
    mat_new(:,:,i) = mean(mat(:,:,I(i):I(i)+window-1),3);
end
mat = mat_new;
clear mat_new;

%% Movie
begonia.path.make_dirs(path);

begonia.util.logging.vlog(1,'Creating tiff video');
mat = uint16(mat);
begonia.util.mat2tiff(mat,path);

end

