function resample(ts,output_dir,merge_frames)

begonia.path.make_dirs(output_dir);

% if exist(output_dir,'dir')
%     rmdir(output_dir,'s');
% end

metadata = begonia.scantype.h5.create_metadata(ts);
metadata.dt = metadata.dt * 10;

% Align
for cycle = 1:ts.cycles
    new_frames = floor(ts.frames_in_cycle(cycle) / merge_frames);
    metadata.frames_in_cycle(cycle) = new_frames;
    for channel = ts.channels
        begonia.util.logging.vlog(2, 'Loading matrix');
        mat = ts.get_mat(cycle,channel);
        mat = mat(:,:,:);
        
        mat_resampled = zeros(size(mat,1),size(mat,2),new_frames,'uint16');
        
        begonia.util.logging.backwrite();
        for i = 1:new_frames
            begonia.util.logging.backwrite(1,'Cycle %d Channel %d Frame %d/%d',cycle,channel,i,new_frames);
            
            mat_resampled(:,:,i) = uint16(mean(mat(:,:,(i-1)*merge_frames+1:i*merge_frames),3));
        end

        % Save as hdf5.
        path_h5 = fullfile(output_dir,metadata.files{cycle, channel});
        begonia.util.logging.vlog(2, 'Saving matrix');
        mat_lazy = begonia.util.h5arr(path_h5,size(mat_resampled),class(mat_resampled));
        mat_lazy(:,:,:) = mat_resampled;
    end
end

% Save metadata:
begonia.util.logging.vlog(2, 'Saving metadata');
save(fullfile(output_dir,'metadata.mat'), 'metadata');

end

