function str = shorten_path(str,varargin)
p = inputParser;
p.addRequired('str',...
    @(x) validateattributes(x,{'char'},{}));
p.addParameter('max_length',60, ...
    @(x) validateattributes(x,{'numeric'},{'integer'}));
p.parse(str,varargin{:});
begonia.util.dump_inputParser_vars_to_caller_workspace(p);

% Adjust max_length by '.../' which is added to the start of the str. 
max_length = max_length - 4;

while length(str) > max_length
    str = strsplit(str,filesep);
    if length(str) == 1
        str = str{1};
        break
    end
    str = fullfile(str{2:end});
end

if str(1) ~= filesep
    str = ['...',filesep,str];
end

end

