% extracts a subvector from a vector, and padds the oerrun with a given
% padding like "nan" if the extraction is beyond the bounds of the vector
function [result, padd_left, padd_right] = extract_and_padd(trace, idx, take_left, take_right, padding)
    if nargin < 5
        if isnumeric(trace)
            padding = nan;
        elseif iscategorical(trace)
            padding = categorical("n/a");
        elseif islogical(trace)
            padding = 0;
        end
    end

    st_start = idx-take_left;
    st_end = idx+take_right;

    padd_left = 0;
    padd_right = 0;

    if st_start <= 0
        padd_left = abs(st_start) + 1;
        st_start = 1;
        st_end = st_end + padd_left ;
    end

    if st_end > length(trace)
        padd_right = st_end - length(trace);
    end

    if size(trace, 1) > size(trace, 2)
        extended = [repmat(padding, padd_left, 1) ; trace ; repmat(padding, padd_right, 1)];
    else
        extended = [repmat(padding, 1, padd_left) trace repmat(padding, 1 , padd_right)];
    end
    result = extended(st_start:st_end);
end