function mat2tiff(mat, path)
assert(strcmp(class(mat),'uint16'), 'input must be uint16.')

s=whos('mat');
if s.bytes > 2^32-1
    % Big tiff.
    new = Tiff(path,'w8');
else
    new = Tiff(path,'w');
end
for frame = 1:size(mat,3)
    % Do not know what these do, but seems they need to be like this.
    new.setTag('Photometric',Tiff.Photometric.MinIsBlack);
    new.setTag('PlanarConfiguration',Tiff.PlanarConfiguration.Chunky);
    % Assume uint16.
    new.setTag('BitsPerSample',16);
    new.setTag('SamplesPerPixel',1);

    new.setTag('ImageLength', size(mat,1));

    new.setTag('ImageWidth', size(mat,2));

    new.write(mat(:,:,frame));
    new.writeDirectory();
end
new.close()