function validatecellstr(x,validStrings,varargin)
% validatecellstr checks if each string inside x is equal to one of the
% valid string. x can either be a char or a cell of char. 
%   validStrings    - cell array of chars
p = inputParser;
p.addParameter('pass_empty',true, ...
    @(x) validateattributes(x,{'logical'},{'nonempty'}));
p.addParameter('pass_char',true, ...
    @(x) validateattributes(x,{'logical'},{'nonempty'}));
p.parse(varargin{:});
begonia.util.dump_inputParser_vars_to_caller_workspace(p);

error_str = sprintf('Expected input to be a cell which matches one of these values:');
error_str = strcat(error_str,'\n\n');
for i = 1:length(validStrings)
    str_tmp = sprintf(' ''%s'',',validStrings{i});
    error_str = strcat(error_str,str_tmp);
end
error_str(end) = [];

if ischar(x) && pass_char
    x = {x};
end

if isempty(x) && ~pass_empty
    str_tmp = sprintf('\n\nBut the input was instead empty.');
    error_str = strcat(error_str,str_tmp);
    error('begonia:validators:invalid_arguments', error_str);
end

if ~iscellstr(x)
    str_tmp = sprintf('\n\nBut the input was instead of type ''%s''.',class(x));
    error_str = strcat(error_str,str_tmp);
    error('begonia:validators:invalid_arguments', error_str);
end

for i = 1:length(x)
    if ~any(strcmp(x{i},validStrings))
        str_tmp = sprintf('\n\nThe input, ''%s'', did not match any of the valid values.',x{i});
        error_str = strcat(error_str,str_tmp);

        error('begonia:validators:invalid_arguments', error_str);
    end
end

end

