function stacks_20180312(path)
global BEGONIA_VERBOSE

stacks = begonia.stack_search.find_stacks(path);
has_old_images = stacks.has_var('images_avg');
stacks = stacks(has_old_images);

for stack = stacks
    if BEGONIA_VERBOSE >= 1
        fprintf('Updating stack: %s\n',stack.path);
    end
    stack.load_var('images_avg');
    stack.load_var('images_std');
    stack.load_var('images_max');
    stack.load_var('clim_orig');
    
    for i = 1:stack.cycles
        for j = 1:stack.channels
            file = sprintf('avg_cycle_%.3d_channel_%.2d.tif',i,j);
            file = fullfile(stack.path,file);
            begonia.util.mat2tiff(uint16(images_avg{i,j}),file); %#ok<*USENS>
            
            file = sprintf('std_cycle_%.3d_channel_%.2d.tif',i,j);
            file = fullfile(stack.path,file);
            begonia.util.mat2tiff(uint16(images_std{i,j}),file);
            
            file = sprintf('max_cycle_%.3d_channel_%.2d.tif',i,j);
            file = fullfile(stack.path,file);
            begonia.util.mat2tiff(uint16(images_max{i,j}),file);
            
            file = 'metadata.mat';
            file = fullfile(stack.path,file);
            tmp = load(file);
            metadata = tmp.metadata;
            metadata.pixel_min_max = clim_orig;
            save(file, 'metadata');
        end
    end
end

end

