classdef Stack < begonia.data_management.DataLocation & dynamicprops
    %STACK main stack class. Is abstract. Includes useful properties and functions. 
    
    properties
        type
        name
        cycles
        channels
        channel_names
        frames_in_cycle
        original_img_dim
        dx
        dy
        dt
        optical_zoom
        record_date
        processing_state
        format
    end
    
    
    methods (Abstract)
        % Returned value can and maybe should be lazy.
        mat = get_stack(self,cycle,channel)
    end
    
    methods
        function obj = Stack(path)
            obj@begonia.data_management.DataLocation(path);
%             if nargin == 0
%                 return
%             end
%             % Remove the ending fileseperator.
%             if ~isempty(path) && path(end) == filesep
%                 path(end) = [];
%             end
%             if isempty(path)
%                 return
%             end
%             obj.path = path;
        end
        
        
        function img = get_avg(self,cycle,channel)
            file = sprintf('avg_cycle_%.3d_channel_%.2d.tif',cycle,channel);
            file = fullfile(self.path,file);
            img = imread(file);
        end
        
        
        function img = get_std(self,cycle,channel)
            file = sprintf('std_cycle_%.3d_channel_%.2d.tif',cycle,channel);
            file = fullfile(self.path,file);
            img = imread(file);
        end
        
        
        function img = get_max(self,cycle,channel)
            file = sprintf('max_cycle_%.3d_channel_%.2d.tif',cycle,channel);
            file = fullfile(self.path,file);
            img = imread(file);
        end
        
        
        function min_max = get_pixel_min_max(self,cycle,channel)
            file = 'metadata.mat';
            file = fullfile(self.path,file);
            tmp = load(file);
            min_max = tmp.metadata.pixel_min_max{cycle,channel};
        end
        
        create_additional_images(self)
        
    end
end

