function metadata = load_default_metadata_struct(stack)
%% Load from metadata file if it exists.

metadata_file = fullfile(stack.path,'metadata.mat');
assert(exist(metadata_file,'file') == 2, ...
    'begonia:invalid_stack:missing_metadata', ...
    'No metadata.mat file found');

load(metadata_file);
assert(exist('metadata','var') == 1, ...
    'begonia:invalid_stack:wrong_metadata', ...
    'metadata file found, but did not contain a metadata variable.');

%% Load properties.
stack.type = metadata.type;
stack.name = metadata.name;
stack.cycles = metadata.cycles;
stack.channels = metadata.channels;
stack.channel_names = metadata.channel_names;
stack.frames_in_cycle = metadata.frames_in_cycle;
stack.original_img_dim = metadata.original_img_dim;
stack.dx = metadata.dx;
stack.dy = metadata.dy;
stack.dt = metadata.dt;
stack.record_date = metadata.record_date;
stack.processing_state = metadata.processing_state;
stack.format = metadata.format;

end

