function mat = apply_filt(mat, func, axis)
dim = size(mat);

% Swap the axis we want to become the first dimention.
intermediate_dim_indices = 1:length(dim);
intermediate_dim_indices(axis) = [];
intermediate_dim_indices = [axis, intermediate_dim_indices];
mat = permute(mat, intermediate_dim_indices);

% Reshape all the other dimentions into columns, making a 2d matrix.
mat = reshape(mat, dim(axis), []);

% Run the function.
mat = func(mat);
axis_new_length = size(mat, 1);

% Reshape back to the correct number of dimentions, though the
% length of the dimention(axis) has changed. 
intermediate_dim = dim(intermediate_dim_indices);
intermediate_dim(1) = axis_new_length;
mat = reshape(mat, intermediate_dim);
% Swap the axis back to the original layout. (Opposite of the first
% swap).
dim_indices = 1:length(dim);
dim_indices(1) = [];
dim_indices = [dim_indices(1:axis-1),1,dim_indices(axis:end)];
mat = permute(mat, dim_indices);
% Remove singelton dimentions.
mat = squeeze(mat);
end

