function f0_vec = histogram_peak(mat)
if ~isfloat(mat)
    mat = single(mat);
end

% If mat is a vector, make it a column vector.
if size(mat,1) == 1
    mat = mat';
end

n_signals = size(mat,2);
f0_vec = zeros(1, n_signals);
for col = 1:n_signals
    signal = mat(:,col);
    
    
    [dist, edge] = histcounts(signal, 500);
    edge = (edge(2:end) + edge(1:end-1))/2;
    [max_val, max_idx] = max(dist);
    f0_vec(col) = edge(max_idx);
end
end

