% stash some data:
stash = begonia.data_management.Stash("C:\Users\knuta\Desktop\stash");
thing = rand(100,100,100);
url = stash.put('randcol', 'random-1', thing);

% recover the data:
thing = stash.get(url);


% stash multiple:
words = ["hello", "world"];

% if you dont want to create your own idents, make them with uuid. You can
% however supply a series of ids you have made yourself to ensure data does
% not get written more than once:
idents = begonia.util.make_uuids(length(words));
urls = stash.puts('dictionary', idents, words);

% get them back: 
words = stash.gets(urls);


% make a dummy table:
ts_name(1,:) = "TS1";
ts_name(2,:) = "TS2";
ts_name(3,:) = "TS3";

data(1,:) = {rand(100,100,100)};
data(2,:) = {rand(100,100,100)};
data(3,:) = {rand(100,100,100)};

meta(1,:) = {"<thing>alpha</thing>"};
meta(2,:) = {"<thing>beta</thing>"};
meta(3,:) = {"<thing>gamma</thing>"};

tab = table(ts_name, data, meta);

% stash the columns 'data' and 'meta':
% you need to specify a namespace and what columns you want to stash:
a = stash.stash_table('unittests', tab, ["data", "meta"]);

% get the data back - no parameters needed beyond table:
b = stash.unstash_table(a);


