
%% Edit
[model, dloc1, dloc2] = makeModel();

% make change:
model.save(dloc1, 'VAR1', "First value set");
model.save(dloc2, 'VAR1', "Second value set");

% assert(var_changed_fired == 2);

assert(~isempty(dloc1.load_var('VAR1')));
assert(dloc1.load_var('VAR1') == model.load(dloc1, 'VAR1'));

model.save(dloc1, 'VAR1', "First value changed");
% assert(var_changed_fired == 3);
assert(dloc1.load_var('VAR1') == "First value changed");


%% Selection

[model, dloc1, dloc2] = makeModel();

% check we can select by data location:
assert(isempty(model.selected));
model.select([dloc1 dloc2]);
assert(ismember(dloc1, model.selected) && ismember(dloc2, model.selected));

% change selection
model.selectByIndicies([2,1]) % should be dloc2
assert(model.selected == dloc2);


%% Transformer

[model, dloc1, dloc2] = makeModel();

dloc1.save_var('test', 10);
dloc1.save_var('test2', 10);
assert(model.load(dloc1, 'test') == 10);
assert(model.load(dloc1, 'test2') == 10);

% apply transformer that adds 1 on load and save:
model.modifiers = [AddOneModifier('test') AddOneModifier('demo')];
assert(model.load(dloc1, 'test') == 11);
assert(model.load(dloc1, 'test2') == 10);

model.save(dloc1, 'test', 10); % will save 10 + 1
assert(model.load(dloc1, 'test') == 12); % will load 11 + 2



%% Action queue:

[model, dloc1, dloc2] = makeModel();
model.enqueueAction('Do it later', @(d,m,l) disp('Just did it'), dloc1, [])
model.enqueueAction('Last one', @(d,m,l) disp('Just did it again'), dloc1, [])

model.runQueue();


%% Non dloc objects:
a = Person('Knut', 'Norvegia');
b = Person('Teresa', 'Bacalhau');

model = xylobium.dledit.model.EditorModel([a,b]);
model.varlist = {'name', 'nationality'};




% list all variables:











