%% create root


[root1, root2, dl1, dl2, dl3, dl4] = setup_test();

identifier = yucca.catalog.identifiers.DummyIdentifier();

% two catalogs and scan them:
cat1 = yucca.catalog.Catalog();
cat1.connect(root1, 'Dummy root 1');
source = cat1.sources(1);
source.rescan([@yucca.catalog.identifiers.dummy_data]);



function [root1, root2, dl1, dl2, dl3, dl4] = setup_test()
    root1 = tempname(); mkdir(root1);
    root2 = tempname(); mkdir(root2);

    dl1 = make_dummy_data(root1, 'data_1');
    dl2 = make_dummy_data(root1, 'data_2');
    dl3 = make_dummy_data(root2, 'data_3');
    dl4 = make_dummy_data(root2, 'data_4');
end

function dloc = make_dummy_data(root_path, name)
    datapath = fullfile(root_path, name);
    mkdir(datapath);
    f = fopen(fullfile(datapath, 'dummy.data') ,'w');
    fprintf(f, 'Dummy data for dummies');
    fclose(f);
    
    dloc = begonia.data_management.DataLocation(datapath);
    dloc.dl_ensure_has_uuid;
end


