%% String expansion

% make temp dloc and save some vars to it:
path = tempname();
mkdir(path);
dloc = begonia.data_management.DataLocation(path);

dloc.save_var('month', 'MAY');
dloc.save_var('name', '(J/R)onny');
dloc.save_var('wrong', struct())

str = 'In the merry month of {$month}, {$name} goes to buy bacon in Sweden';
expected = 'In the merry month of MAY, (J/R)onny goes to buy bacon in Sweden';

% perform expansion:
result = yucca.util.expandStringDlocVars(str, dloc);
assert(strcmp(result, expected));

% error handling:
str = 'In the merry month of {$months}, {$wrong} goes to buy bacon in Sweden';
expected = 'In the merry month of {ERR:NOT_FOUND:months}, {ERR:TYPE_NOT_CHAR:struct} goes to buy bacon in Sweden';

result = yucca.util.expandStringDlocVars(str, dloc);
assert(strcmp(result, expected));