function gui_oscope(root_directory)
if nargin < 1
    root_directory = uigetdir;
end

if isempty(root_directory) || isequal(root_directory,0)
    return;
end
%% Find oscope tseries

begonia.util.logging.vlog(1,'Finding tif files.');
tif_files = begonia.path.find_files(root_directory,'.tif',true);

tseries = begonia.path.init_classes_from_paths(tif_files,{@begonia.scantype.oscope.OSTseries});

objs = xylobium.align.TSeriesWrapper.empty;
for i = 1:length(tseries)
    objs(i) = xylobium.align.TSeriesWrapper();
    objs(i).path = tseries(i).path;
    objs(i).tseries = tseries(i);
    objs(i).name = tseries(i).name;
    objs(i).frames_in_cycle = tseries(i).frames_in_cycle;
end
%% 
% For now create an alignment conf automatically.
alignment_conf = begonia.tseries_operations.AlignmentSettings();
warning off
alignment_conf = struct(alignment_conf);
warning on
alignment_conf.bin_width = 1e4;

%%
actions(1) = xylobium.dledit.Action('Align', ...
    @(d,m,e) xylobium.align.align_tseries(d.tseries,root_directory,alignment_conf), ...
    true, ...
    false);
actions(2) = xylobium.dledit.Action('Copy to TSeriesH5', ...
    @(d,m,e) xylobium.align.h5_transform(d.tseries,root_directory), ...
    true, ...
    false);

%% Modifiers
mods(1) = xylobium.align.AlignmentMod(root_directory);
mods(2) = xylobium.align.TransferMod(root_directory);

%%
xylobium.dledit.Editor(objs, actions, {'path','name','frames_in_cycle','is_aligned','is_h5'},mods);
end

