function removeCompressed(dloc, model, editor)
    % check we have transmitted:
    if ~dloc.has_var('transmitted') || ~strcmp(dloc.load_var('transmitted'), 'ok')
        error('Transmit first!  If you need to delete the ZIP file, do so manually');
    end


    if dloc.has_var('compressed')
        zipfile = dloc.load_var('compressed');
        if ~exist(zipfile, 'file')
            dloc.clear_var('compressed');
            error('Referenced compressed file does not exist. Removed already?')
        end
        
        delete(zipfile);
        model.save(dloc, 'compressed', 'deleted');
        model.save(dloc, 'backup_done', 'ok');
    else
        error('Need to compress before it can be cleaned.')
    end

end

