function transmit(dloc, model, editor)

    % check we have zip file, and that it exists:
    zip_path = [];
    if dloc.has_var('compressed')
        zip_path = dloc.load_var('compressed');
        if ~exist(zip_path, 'file')
            dloc.clear_var('compressed')
            error('Compressed archive not found for this dloc. File deleted?');
        end
    else
        error('Need to compress first');
    end
    
    % run shell command to transmit file:
    cmd_raw = editor.config.backup_cmd;
    cmd = yucca.util.expandStringDlocVars(cmd_raw, dloc);
    disp(['Transmitting using: ' cmd]);
    [status,output] = system(cmd);
    
    if status == 0
        model.save(dloc, 'transmitted', 'ok');
    else
        model.save(dloc, 'transmitted', 'err');
        error(['Transmision command ended with error: ' status output]);
    end

end

