classdef BackupToolConfig < handle
    %STACKPROCESSORCONFIG Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        setup_sheet
        table_backups 
        table_config
        
        backup_cmd
        backup_paths
    end
    
    methods
        function obj = BackupToolConfig(setup_sheet)
            obj.setup_sheet = setup_sheet;
            obj.table_backups = readtable(setup_sheet, 'sheet', 'Backups');
            obj.table_config = readtable(setup_sheet, 'sheet', 'Config');
            
            if isempty(obj.table_backups) || isempty(obj.table_config)
                error('Cannot load setup sheet. Look at template for proper configuration');
            end
        end

        
        % command to backup data to remote storage
        function backup_cmd = get.backup_cmd(obj)
            t = obj.table_config;
            backup_cmd = t(strcmp(t.Key, 'backup.command'),:).Setting{:};
        end
        

        % list of tseries to include
        function paths = get.backup_paths(obj)
            paths = obj.table_backups.Path;
        end
        

    end
end

