classdef ColoredPushbutton < handle
    
    properties (SetObservable)
        String
        Colors = {[0.9400,0.9400,0.9400],'green'}
        Value = false
    end
    
    properties (Access = private)
        button
    end
    
    methods
        function self = ColoredPushbutton(parent)
            button = uicontrol('Parent',parent,'Style', 'pushbutton');
            button.Callback = @(~,~) self.change_value();
            
            self.button = button;
            
            self.Value = false;
        end
        
        function change_value(self)
            self.Value = ~self.Value;
        end
        
        function set.Value(self,val)
            assert(val == 1 || val == 0);
            self.Value = val;
            self.button.BackgroundColor = self.Colors{self.Value+1};
        end
        
        function set.String(self,val)
            self.button.String = val;
        end
        
        function val = get.String(self)
            val = self.button.String;
        end
        
        function set.Colors(self,val)
            assert(iscell(val) && length(val) == 2);
            self.Colors = val;
            self.button.BackgroundColor = self.Colors{self.Value+1};
        end
        
        function delete(self)
            delete(self.button);
        end
    end
end

