classdef ColormapPicker < handle
    properties (SetObservable,AbortSet)
        parent
        
        axes
    end
    
    properties (Access = private)
        popupmenu
    end
    
    methods
        function set.axes(self,axes)
            self.axes = axes;
            self.update();
        end
        
        function set.parent(self,parent)
            if ~isempty(self.popupmenu)
                delete(self.popupmenu)
            end
            
            if isempty(parent)
                self.popupmenu = [];
                self.parent = [];
            else
                popupmenu = uicontrol('Parent',parent,'Style','popupmenu');
                popupmenu.Callback = @(~,~) self.callback_popupmenu();
                self.popupmenu = popupmenu;
                self.parent = parent;
            end
            %%
            self.update();
        end
    end
    
    methods (Access = private)
        function update(self)
            
            if isempty(self.popupmenu)
                return;
            end
            
            if isempty(self.axes)
                self.popupmenu.String = {'n/a'};
                self.popupmenu.Value = 1;
                return;
            end
            
            colormaps = {};
            colormaps{end+1} = 'turbo';
            colormaps{end+1} = 'viridis';
            colormaps{end+1} = 'gray';
            
            self.popupmenu.String = colormaps;
            
            switch self.popupmenu.Value
                case 1
                    colormap(self.axes,begonia.colormaps.turbo);
                case 2
                    colormap(self.axes,begonia.colormaps.viridis);
                case 3
                    colormap(self.axes,gray);
            end
        end
        
        function callback_popupmenu(self)
            if isempty(self.axes)
                self.popupmenu.Value = 1;
                return;
            end
            self.update();
        end
    end
end

