classdef RoiListbox < handle
    
    properties (SetObservable,AbortSet)
        parent
        
        roi_array_model
    end
    
    properties (Access = private)
        container
        
        listbox
        
        listener_roi_array_model
    end
    
    methods
        function set.parent(self,parent)
            delete(self.container)
            
            self.parent = parent;
            
            if isempty(parent)
                return;
            end
            %% vbox
            vbox = uix.VBox('Parent',parent);
            self.container = vbox;
            %% text
            text = uix.Text('Parent',vbox);
            text.VerticalAlignment = 'middle';
            text.String = 'ROIs';
            text.FontSize = 14;
            %% listbox
            listbox = uicontrol('Parent',vbox,'Style','listbox');
            listbox.Callback = @(~,~) self.listbox_callback();
            self.listbox = listbox;
            %% other
            vbox.Heights = [20,-1];
            
        end
        
        
        function set.roi_array_model(self,roi_array_model)
            delete(self.listener_roi_array_model);
            
            self.roi_array_model = roi_array_model;
            
            if isempty(roi_array_model)
                self.redraw();
                return;
            end
            
            self.listener_roi_array_model = roi_array_model.addlistener('roi_array','PostSet',@(~,~) self.redraw());
            self.listener_roi_array_model(2) = roi_array_model.addlistener('selected_rois','PostSet',@(~,~) self.redraw());
            
            self.redraw();
        end
        
    end
    
    methods (Access = private)
        function listbox_callback(self)
            if isempty(self.roi_array_model)
                return;
            end
            self.roi_array_model.selected_rois = self.listbox.Value;
        end
        
        function redraw(self)
            if isempty(self.parent)
                return;
            end
            
            m = self.roi_array_model;
            if isempty(m.roi_array)
                self.listbox.String = {};
                self.listbox.Value = [];
            else
                self.listbox.Max = length(m.roi_names);
                self.listbox.String = m.roi_names;
                self.listbox.Value = m.selected_rois;
            end
        end
    end
end

