classdef RoiAxesOverlayControl < handle
    
    properties (SetAccess = private)
        roi_array_model
        roi_axes_overlay
        button_remove_offset
        button_save_rois
    end
    
    methods
        function self = RoiAxesOverlayControl(parent,roi_axes_overlay,roi_array_model)
            self.roi_array_model = roi_array_model;
            roi_axes_overlay.addlistener('ModeChanged',@(~,~) self.on_mode_change());
            self.roi_axes_overlay = roi_axes_overlay;
            
            %%
            container = uix.VBox('Parent',parent);
            
            %%
%             text_mode = uix.Text('Parent',container);
%             text_mode.VerticalAlignment = 'middle';
%             text_mode.String = 'ROI Edit Mode';
            
%             tab_group = uitabgroup(container);
%             tab_draw = uitab(tab_group,'Title','Draw');
%             tab_dynamic_position = uitab(tab_group,'Title','Draw');
            
%             popupmenu_mode = uicontrol('Parent',container,'Style','popupmenu');
%             popupmenu_mode.String = roi_axes_overlay.modes;
%             popupmenu_mode.Callback = @(~,~) self.callback_popupmenu();
%             self.popupmenu_mode = popupmenu_mode;

            button_remove_offset = uicontrol('Parent',container,'Style','pushbutton');
            button_remove_offset.String = 'Remove Offset';
            button_remove_offset.Callback = @(~,~) self.callback_button_clear_offset;
            self.button_remove_offset = button_remove_offset;
            
            
            button_save_rois = uicontrol('Parent',container,'Style','pushbutton');
            button_save_rois.String = 'Save ROIs';
            button_save_rois.Callback = @(~,~) self.callback_button_save_rois;
            self.button_save_rois = button_save_rois;
            %%
            container.Spacing = 10;
            container.Heights = [20,20];
            container.Padding = 20;
            %%
            self.on_mode_change();
        end
        
    end
    
    methods (Access = private)
        function callback_button_save_rois(self)
            self.roi_array_model.save_rois();
        end
        
        function callback_button_clear_offset(self)
            r = self.roi_array_model;
            if isempty(r.selected_rois)
                return
            end
            r.clear_offsets(r.selected_rois);
        end
        
        function on_mode_change(self)
%             i = find(strcmp(self.roi_axes_overlay.mode,self.roi_axes_overlay.modes));
%             self.popupmenu_mode.Value = i;
        end
%         
%         function callback_popupmenu(self)
%             if isempty(self.popupmenu_mode.String)
%                 return;
%             end
%             new_mode = self.popupmenu_mode.String{self.popupmenu_mode.Value};
%             self.roi_axes_overlay.mode = new_mode;
%         end
        
    end
end

