classdef RoiListbox < handle
    properties (SetAccess = private)
        roi_array_model
        
        listbox
    end
    
    methods
        function self = RoiListbox(parent,roi_array_model)
            self.roi_array_model = roi_array_model;
            %% vbox
            vbox = uix.VBox('Parent',parent);
            %% text
            text = uix.Text('Parent',vbox);
            text.VerticalAlignment = 'middle';
            text.String = 'ROIs';
            text.FontSize = 14;
            %% listbox
            listbox = uicontrol('Parent',vbox,'Style','listbox');
            listbox.Callback = @(~,~) self.listbox_callback();
            self.listbox = listbox;
            %% other
            vbox.Heights = [20,-1];
            
            roi_array_model.addlistener('RoiArrayChanged',@(~,~) self.populate_list());
            roi_array_model.addlistener('SelectedRoisChanged',@(~,~) self.change_selection());
            
            self.populate_list();
        end
    end
    
    methods (Access = private)
        function listbox_callback(self)
            self.roi_array_model.selected_rois = self.listbox.Value;
        end
        
        function populate_list(self)
            m = self.roi_array_model;
            if isempty(m.roi_array)
                self.listbox.String = {};
                self.listbox.Value = [];
            else
                self.listbox.Max = length(m.roi_names);
                self.listbox.String = m.roi_names;
                self.listbox.Value = m.selected_rois;
            end
        end
        
        function change_selection(self)
            self.listbox.Value = self.roi_array_model.selected_rois;
        end
    end
end

