classdef TSeriesControlPanel < handle
    %TSERIESCONTROLPANEL Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (SetAccess = private)
        tseries_model
        
        text_contrast
        text_contrast_left
        text_contrast_right
        jslider_contrast
    end
    
    methods
        function self = TSeriesControlPanel(parent,tseries_model)
            tseries_model.addlistener('TSeriesChanged',@(~,~) self.redraw());
            tseries_model.addlistener('CLimChanged',@(~,~) self.redraw());
            self.tseries_model = tseries_model;
            
            %%
            vbox = uix.VBox('Parent',parent);
            %%
            text_contrast = uix.Text('Parent',vbox);
            text_contrast.String = 'Contrast';
            text_contrast.FontSize = 14;
            self.text_contrast = text_contrast;
            %%
            sub_box = uix.HBox('Parent',vbox);
            text_contrast_left = uix.Text('Parent',sub_box);
            text_contrast_right = uix.Text('Parent',sub_box);
            text_contrast_left.String = 'N/A';
            text_contrast_right.String = 'N/A';
            text_contrast_left.HorizontalAlignment = 'left';
            text_contrast_right.HorizontalAlignment = 'right';
            self.text_contrast_left = text_contrast_left;
            self.text_contrast_right = text_contrast_right;
            %%
            jslider = com.jidesoft.swing.RangeSlider();
            [jslider_contrast,jslider_contrast_container] = javacomponent(jslider);
            jslider_contrast_container.Parent = vbox;
            jslider_contrast.Minimum = 0;
            jslider_contrast.Maximum = 1000;
            jslider_contrast.Low = 0;
            jslider_contrast.High = 1000;
            jslider_callback_handle = handle(jslider_contrast);
            jslider_callback_handle.MouseDraggedCallback = @(~,~) self.callback_jslider();
            self.jslider_contrast = jslider_contrast;
            %%
            vbox.Heights = [20,20,20];
            
        end
    end
    
    methods (Access = private)
        function callback_jslider(self)
            clim_maxmin = self.tseries_model.clim_maxmin;
            clim_val = [self.jslider_contrast.Low,self.jslider_contrast.High];
            clim_ratio = clim_val/1000;
            clim = clim_ratio*(clim_maxmin(2)-clim_maxmin(1)) + clim_maxmin(1);
            clim = round(clim);
            self.tseries_model.clim = clim;
        end
        
        function redraw(self)
            %% CLim
            % Update text
            clim = self.tseries_model.clim;
            clim_maxmin = self.tseries_model.clim_maxmin;
            self.text_contrast_left.String = num2str(clim(1));
            self.text_contrast_right.String = num2str(clim(2));
            % Update slider
            clim_ratio = (clim - clim_maxmin(1))/(clim_maxmin(2)-clim_maxmin(1));
            clim_val = round(clim_ratio*1000);
            self.jslider_contrast.Low = clim_val(1);
            self.jslider_contrast.High = clim_val(2);
            
        end
        
        
    end
end

