classdef TSeriesPicker < handle
    properties (SetAccess = private)
        tseries_model
        
        previous_parent_path = ''
        
        popupmenu
    end
    
    methods
        function self = TSeriesPicker(parent,tseries_model)
            tseries_model.addlistener('TSeriesChanged',@(~,~) self.redraw());
            self.tseries_model = tseries_model;
            %% Popupmenu
            popupmenu = uicontrol('Parent',parent,'Style','popupmenu');
            popupmenu.Callback = @(~,~) self.callback_popupmenu();
            self.popupmenu = popupmenu;
            %%
            self.redraw();
        end
    end
    
    methods (Access = private)
        function redraw(self)
            t = self.tseries_model;
            elem = {};
            elem{1} = 'Search Directory';
            for i = 1:length(t.tseries_list)
                elem{i+1} = t.tseries_list(i).name;
            end
            self.popupmenu.String = elem;
            
            i = find(t.tseries == t.tseries_list) + 1;
            if isempty(i)
                i = 1;
            end
            self.popupmenu.Value = i;
        end
        
        function callback_popupmenu(self)
            if self.popupmenu.Value == 1
                path = uigetdir(self.previous_parent_path,'Find TSeries');
                if path == 0
                    return;
                end

                self.previous_parent_path = fileparts(path);

                tseries_list = begonia.scantype.find_tseries(path);
                self.tseries_model.load_tseries(tseries_list);
                self.redraw();
            else
                tseries = self.tseries_model.tseries_list(self.popupmenu.Value - 1);
                self.tseries_model.load_tseries(tseries);
            end
        end
    end
end

