classdef TSeriesVideo < handle
    
    properties
        
    end
    
    properties (SetAccess = private)
        video_axes
        video_imhandle
        
        tseries_model
    end
    
    methods
        function self = TSeriesVideo(parent,tseries_model)
            self.tseries_model = tseries_model;
            %% axes and image handle
            video_axes = axes('Parent',parent);
            self.video_axes = video_axes;
            
            imhandle = imagesc(video_axes,zeros(512,512));
            self.video_imhandle = imhandle;
            
            colormap(gray);
            
            video_axes.XTick = [];
            video_axes.YTick = [];
            video_axes.DataAspectRatio = [1,1,1];
            video_axes.ActivePositionProperty = 'position';
            
            tseries_model.addlistener('TSeriesChanged',@(~,~) self.on_video_change());
            tseries_model.addlistener('FrameChanged',@(~,~) self.on_frame_change());
            tseries_model.addlistener('CLimChanged',@(~,~) self.on_clim_change());
            %% other
            self.on_reset();
        end
        
    end
    
    methods (Access = private)
        
        function on_clim_change(self)
            if isempty(self.tseries_model.tseries)
                return;
            end
            self.video_axes.CLim = self.tseries_model.clim;
        end
        
        function on_reset(self)
            self.video_imhandle.CData = zeros(512,512);
        end
        
        function on_video_change(self)
            self.video_axes.CLim = self.tseries_model.clim;
            self.video_axes.XLim = [1,self.tseries_model.video_dim(2)];
            self.video_axes.YLim = [1,self.tseries_model.video_dim(1)];
        end
        
        function on_frame_change(self)
            self.video_imhandle.CData = self.tseries_model.current_img;
        end
    end
end

