function tbl = default_filter(trials,var_name)

% Default table if returning early.
dummy_data = repmat({''},length(trials),1);
dummy_data = categorical(dummy_data);
tbl = table(dummy_data,'VariableNames',{var_name});

assert(ischar(var_name));

data = cell(length(trials),1);

begonia.util.logging.backwrite();
for i = 1:length(trials)
    begonia.util.logging.backwrite(1,'loading ''%s'' %d/%d',var_name,i,length(trials));
    
    data{i} = trials(i).load_var(var_name,'');
end

% Check that all data is "homogeneous"
data_types = {};
for i = 1:length(trials)
    if ~isempty(data{i})
        data_types{end+1} = class(data{i});
    end
end

data_types = unique(data_types);
if length(data_types) >= 2
    warning(sprintf('The data stored under the variable name ''%s'' contains multiple data types. Returning undefined values for all trials.',var_name));
    return;
end

% Convert all data to structs.
for i = 1:length(trials)
    if ~isstruct(data{i})
        data{i} = struct(var_name,data{i});
    end
end

data = cat(1,data{:});

tbl = struct2table(data,'AsArray',true);

end

