function configNoRMCorre(tseries, model, editor)

    if length(tseries) > 1
       ts = tseries(1); 
    else
        ts = tseries
    end

    if ts.has_var('ncconfig')
        settings = ts.load_var('ncconfig');
    else
        settings = begonia.stack_operations.AlignmentSettings();
    end
    
    dialog = xylobium.ncconfig.NoRMCorreConfigurator(settings);
    addlistener(dialog ...
        , 'on_save' ...
        , @(~,~) save_all(tseries, dialog.settings, model));
end

% callback for saving to all provided tseries
function save_all(tseries, settings, model)
    for ts = tseries
        model.save(ts, 'ncconfig', settings)
    end
end