function extract_roa(tseries, model, editor)
    import begonia.util.logging.*;
    tic;
    vlog(1, ['(StackProcessor:extract_roa) Starting for ' tseries.name]);
    
    % get aligned:
    if ~tseries.has_var('aligned')
        error('Can only extarct RoA for aligned stacks');
    end
    
    aligned = begonia.scantype.find_scans(tseries.load_var('aligned'));
    
    % processing chain for regions of activity:
    begonia.stack_modules.channel_traces.write_vars(aligned);
    begonia.stack_modules.drift_correction.write_vars(aligned);
    
    roa_config = begonia.stack_modules.roa_mask.original.roa_config();
    begonia.stack_modules.roa_mask.original.write_vars(aligned, roa_config);
    
    %begonia.stack_modules.roa_mask.write_vars(aligned);
    begonia.stack_modules.roa.write_vars(aligned);
end

