function makeProxy(tseries, model, editor)
    if ~tseries.has_var('aligned')
        error('Stack needs to be aligned before proxy can be generated. Manual conversion of raw stack can be done - see docs.');
    end
    
    % get the aligned stack:
    aligned_path = model.load(tseries, 'aligned');
    stack = begonia.scantype.find_scans(aligned_path);
    
    % make dirs:
    if editor.config.proxy_output_dir == "_SAME_"
        parent = fileparts(tseries.path);   % parent dir
        proxy_path = fullfile(parent, [tseries.name '_prox']);
    else
        mkdir(editor.config.proxy_output_dir);
        proxy_path = fullfile(editor.config.proxy_output_dir ...
            ,[tseries.name '_prox']);
    end
    
    
    mkdir(proxy_path);
    
    % generate the proxy stack by creating a grid-png system + metadata:
    begonia.scantype.proxy.create(stack, proxy_path, 10, 5);
    
    % save the output through the model, to notify the editor:
    model.save(tseries, 'proxy', proxy_path);
end


