function makeSummaryDir(tseries, model, editor)

    % make summary dir if it does not exist:
    sdir = editor.config.summary_dir;
    if ~exist(sdir, 'dir')
        mkdir(sdir);
    end
    
    % check if we have one with the name of the tseries:
    tsdir = fullfile(sdir, tseries.name);
    if ~exist(tsdir, 'dir')
        mkdir(tsdir);
        
    end
    
    % copy preview video:
    if tseries.has_var('vidprev')
        vidfile = tseries.load_var('vidprev');
        copyfile(vidfile, tsdir);
    end
    
    % copy xml file:
    xml_file = fullfile(tseries.path, [tseries.name '.xml']);
    if exist(xml_file, 'file')
        copyfile(xml_file, tsdir);
    else
        warning('No XML file found for tseries')
    end
    

    % keep reference in datalocation:
    model.save(tseries, 'summary', tsdir);
end


