function processed_stacks(tseries, model, editor)
    chosen = questdlg('What stack?' ...
        , 'Open matviewer..'...
        , 'aligned', 'proxy', 'proxy');
    
    paths = arrayfun(@(ts) ts.load_var(chosen,[]) ...
        , tseries ...
        , 'UniformOutput', false);
    
    stacks  = [];
    for path = paths
        disp(['Opening ' path]);
        
        switch chosen
            case 'aligned'
                stack = begonia.scantype.h5.TSeriesH5(path{:});
            case 'proxy'
                stack = begonia.scantype.proxy.TSeriesProxy(path{:});
                
        end
        stacks = [stacks stack];
    end
    
    % open a simple viewer:
    xylobium.dledit.Editor(stacks, {}, {'format', 'name', 'path', 'uuid', 'start_time', 'roa_array', 'proxy_src_uuid', 'frames_in_cycle', });
    
end