function sync_stacks(tseries, ~, editor)
    import begonia.util.logging.*;

    vlog(1, 'Synchronizing stack variables')
    stacks =  begonia.data_management.DataLocation.empty();
    stacks(1) = tseries;
    if tseries.has_var('aligned')
        vlog(1, 'Found aligned, will sync')
        stacks(2) = begonia.scantype.h5.TSeriesH5(...
            tseries.load_var('aligned'));
    end
    
    if tseries.has_var('proxy')
        vlog(1, 'Found proxy, will sync')
        stacks(3) = begonia.scantype.proxy.TSeriesProxy( ...
            tseries.load_var('proxy'));
    end
    
    % no need to synch with oneself:
    if length(stacks) < 2
        return
    end
    
    % sync info to raw stack:
    master = stacks(1);
    for i = 2:length(stacks)
        master.dl_update_from(stacks(i));
    end
    
    % sync info from raw stack to the others:
    for i = 2:length(stacks)
        slave = stacks(i);
        slave.dl_update_from(master);
    end
    
    editor.datagrid.reloadTable(); 
end


