classdef AlignmentSettingsModifier < xylobium.dledit.model.Modifier
    methods
        
        function obj = AlignmentSettingsModifier(key)
            obj = obj@xylobium.dledit.model.Modifier(key);
        end
        
        function value = onLoad(~, dloc, ~, ~)
            % get path and extract last part:
            value = [];
            if dloc.has_var('ncconfig')
                ncconf = dloc.load_var('ncconfig');
                if ~isempty(ncconf)
                    if ncconf.rigid
                        value = ['CH' num2str(ncconf.channel) ' rigid'] ;
                    else
                        value = ['CH' num2str(ncconf.channel) ' non-rigid'] ;
                    end
                end
            end
        end
        
        function value = onSave(~, dloc, ~, ~)
            if dloc.has_var('ncconfig')
                value = dloc.load_var('ncconfig');
            else
                value = [];
            end
        end
        
    end
end

