function tab = make_vessel_table(tseries)

    tab = table();
    tab.ts_name = categorical();
    tab.ts_uuid = categorical();
    tab.vessel_ids = categorical();
    
    row = 1;
    for ts = tseries
        
        if ts.has_var('vestool_results')
            config = ts.load_var('vestool_config');
            results = ts.load_var('vestool_results');
            valids = results.frame_analysed;
            
            fnrs = 1:length(results.time_s);
            vfs = fnrs(valids);
            
            for i = 1:length(results.maker_names)
                tab.ts_name(row) = ts.name;
                tab.ts_uuid(row) = ts.uuid;
        
                tab.tseries_dx(row) = ts.dx;
                tab.tseries_dt(row) = ts.dt;
                
                tab.vessel_ids(row) = results.maker_names(i);
                tab.start_points(row) = { config.markers(i).start_point };
                tab.end_points(row) = { config.markers(i).end_point } ;
                tab.time_s(row) = { results.time_s(valids) };
                tab.frame_nr(row) = { vfs };
                tab.distance_px(row) = { results.diam_left_right_dynamic_mean(vfs,i) };
                %tab.distance_um(row) = { results.diam_left_right_dynamic_mean(vfs,:) * ts.dx };
                tab.distance_locked_tresh_px(row) = { results.diam_locked_mean(vfs,i) };
                %tab.distance_locked_tresh_um(row) = { results.diam_locked_mean(vfs,:) * ts.dx };

                tab.area_under_tresh(row) = { results.area_under_min_treshold(vfs,i) };
                
                row = row + 1;
            end
            
            %tab_ves.channel_fluo(row) = { results.channel_mean_fluo(valids) };
            
        end
        
        
    end

end


function results = filter_by_valid(valids, data)
    for i = size(data,2)
        
    end
end