classdef VesselTool < xylobium.dledit.Editor
    %VESSELTOOLEDITOR Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        tseries
        video_trace_output_dir
    end
    
    methods
        function obj = VesselTool(tss)
            import xylobium.vesseltool.*;
            
            actions = VesselTool.get_default_actions();
            vars = {'name', 'start_time', 'vestool_config', 'vestool_results', 'vestool_ds', 'vestool_video'};
            obj = obj@xylobium.dledit.Editor(tss, actions, vars);
        
            obj.tseries = tss;
            obj.video_trace_output_dir = char.empty;
        end
        
    end
    
    methods (Static)
        
        function actions = get_default_actions()
            import xylobium.dledit.*;
            import xylobium.vesseltool.actions.*;

            ac_open_mtool = Action(...
                'Editor', @(d, m, e) open_editor(d), false, true, 'control-shift-e');

            ac_open_ctool = Action(...
                'Config tool', @(d, m, e) open_configtool(d), false, true, 'control-shift-c');

            ac_full_analysis = Action(...
                'Analyse (all)', @(d, m, e) full_analysis(d, m), true, false, 'control-shift-a');

            ac_ds30_analysis = Action(...
                'Analyse (1:30)', @(d, m, e) ds30_analysis(d, m), true, false, 'control-shift-1');

            ac_ds100_analysis = Action(...
                'Analyse (1:100)', @(d, m, e) ds100_analysis(d, m), true, false, 'control-shift-2');

            ac_ds1000_analysis = Action(...
                'Analyse (1:1000)', @(d, m, e) ds1000_analysis(d, m), true, false, 'control-shift-3');

            ac_video_trace = Action(...
                'Generate video (1:100)', @(d, m, e) video_trace(d, m, e), true, false);

            ac_video_trace_cust = Action(...
                'Generate video (1:10)', @(d, m, e) video_trace_custom(d, m, e), true, false);
            
             ac_video_output_dir = Action(...
                'Set video output dir', @(d, m, e) set_video_outputdir(d, m, e), false, false);
            
            ac_plot_results = Action(...
                'View results (z-score)', @(d, m, e) plot_results(d), true, false, 'control-shift-r');
            
            ac_plot_results_dist = Action(...
                'View results (dist)', @(d, m, e) plot_results_dist(d), true, false, 'control-shift-z');

            ac_export_table = Action(...
                'Export table...', @(d, m, e) export_table(d), false, true, 'control-shift-t');

            
            actions = [ ...
                ac_open_ctool ...
                ac_full_analysis ...
                ac_ds30_analysis ...
                ac_ds100_analysis ...
                ac_ds1000_analysis ...
                ac_video_trace ...
                ac_video_trace_cust ...
                ac_video_output_dir ... 
                ac_plot_results ...
                ac_plot_results_dist ...
                ac_export_table];
        end
    end
end

