function log = read_logfile(logpath)

if ~exist(logpath,'file')
    log = array2table(cell(0,4), ...
        'VariableNames',{'Tick','Time','Code','Message'});
    return;
end

log = fileread(logpath);
log = strsplit(log,{',','\n'});
if isempty(log{end})
    log(end) = [];
end
log = reshape(log,4,[])';
log = cell2table(log,'VariableNames',{'Tick','Time','Code','Message'});
log.Tick = str2double(log.Tick);

time_formats = {'HH:mm:ss.SSS','hh:mm:ss aa'};
% Try each of the time formats, break if successful.
for i = 1:length(time_formats)
    try
        log.Time = datetime(log.Time,'InputFormat',time_formats{i});
        break
    catch e
        if ~strcmp(e.identifier,'MATLAB:datetime:ParseErrs')
            rethrow(e);
        end
    end
end
log.Code = strip(log.Code);
log.Message = strip(log.Message);

end

