classdef Memento < handle
    %MEMENTO Summary of this class goes here
    %   Detailed explanation goes here
    
    
    properties
        actions = calendula.actions.Action.empty(0);
        
        action_index = 0;
    end
    
    methods
        
        function undo(self)
            if self.action_index <= 1
                return
            end
            action = self.actions(self.action_index);
            action.undo();
            self.action_index = self.action_index - 1;
        end
        
        
        function redo(self)
            if self.action_index >= length(self.actions)
                return
            end
            self.action_index = self.action_index + 1;
            action = self.actions(self.action_index);
            action.do();
        end
        
        
        function do_and_record_action(self,action)
            % Remove future actions if we have done undo's and now adding
            % new actions.
            if self.action_index < length(self.actions)
                self.actions(self.action_index+1:end) = [];
            end
            
            self.actions(end+1,:) = action;
            action.do();
            self.action_index = self.action_index + 1;
        end
        
        function action = get_current_action(self)
            if self.action_index <= 0
                action = [];
            else
                action = self.actions(self.action_index);
            end
        end
        
    end
    
end

