classdef stack_roi < handle
    
    properties
        fig
        
        gui_roi_list
        gui_stack_display
        
        button_panel
    end
    
    methods
        function self = stack_roi()
            %% Create fig
            fig = figure;
            fig.Name = 'Regions of Interest';
            fig.NumberTitle = 'off';
            fig.Units = 'centimeter';
            fig.Position(1:2) = [5,5];
            self.fig = fig;
            
            %% Load gui components.
            gui_roi_list = calendula.gui_components.roi_list(fig);
            self.gui_roi_list = gui_roi_list;
            
            gui_stack_display = calendula.gui_components.stack_display(fig);
            self.gui_stack_display = gui_stack_display;
            
            button_panel = gui_roi_list.button_panel;
            self.button_panel = button_panel;
            
            %% Reposition gui objects
            gui_stack_display.panel.Position(1:2) = [1,1];
            
            gui_roi_list.listbox_rois.Position(1:2) = [15,1];
            
            gui_roi_list.panel.Position(1:2) = [18,1];
            
            begonia.gui_tools.autosize_container(fig,0.5);
            % Enables rescaling.
            set(findall(fig, '-property', 'Units' ), 'Units', 'Normalized')
            
        end
    end
    
end

