function [mat,f0_arr] = filter_signal_neurons(mat, dt)
if isempty(mat)
    f0_arr = [];
    mat = [];
    return
end

window_dt = 0.1; %seconds
sigma = ceil(window_dt/dt);

filter_vec = begonia.util.gausswin(sigma);

mat_filt = convn(mat,filter_vec,'same');

mat_filt = round(mat_filt);

f0_arr = mode(mat_filt,1);

mat = (mat ./ f0_arr) - 1;

% Old code
% window_dt = 0.1; %seconds
% sigma = round(window_dt/dt);
% mat = begonia.vector_functions.gaussian(mat,sigma);
% f0_arr = begonia.vector_functions.histogram_peak(mat);
% mat = (mat - f0_arr)./f0_arr;
% % Remove some drifting.
% mat = mat - begonia.vector_functions.gaussian(mat, round(5/dt));

end

