function ca_signal_df_f0 = read(stack)


roi_array = stack.load_var('roi_array');
roi_array = calendula.RoI(roi_array);

ca_signal = stack.load_var('ca_signal');

drift_correction_trace = stack.load_var('drift_correction_trace');

path = stack.path;
path = begonia.util.logging.shorten_path(path);
str = sprintf('Extracting df_f0 roi signals: %s',path);
begonia.util.logging.vlog(2,str);

signal = ca_signal.Data;

signal = signal .* drift_correction_trace;


% Astrocytes / channel 1
ast_I = {roi_array.group} ~= "NS";
ast = signal(:,ast_I);
ast = calendula.stack_modules.ca_signal_df_f0.filter_signal_astrocytes(ast,stack.dt);

neu_I = {roi_array.group} == "NS";
neu = signal(:,neu_I);
neu = calendula.stack_modules.ca_signal_df_f0.filter_signal_neurons(neu,stack.dt);

signal(:,ast_I) = ast;
signal(:,neu_I) = neu;

ca_signal_df_f0 = timeseries(signal,ca_signal.Time,'Name','ca_signal_df_f0');

end

