function ca_signal_neurons_subtracted = read(stack)
% Print
path = stack.path;
path = begonia.util.logging.shorten_path(path);
str = sprintf('Subtracting doughnut signal : %s',path);
begonia.util.logging.vlog(1,str);

%% Load
ca_signal_doughnuts = stack.load_var('ca_signal_doughnuts');
roi_array = stack.load_var('roi_array');
ca_signal = stack.load_var('ca_signal');
%%
neu_idx = {roi_array.group} == "NS";

t = ca_signal.Time;

roi_neurons = roi_array(neu_idx);

roi_neurons_signal = ca_signal.Data(:,neu_idx);

ca_signal_doughnuts = ca_signal_doughnuts.Data;

[~,f0] = calendula.stack_modules.ca_signal_df_f0.filter_signal_neurons(roi_neurons_signal,stack.dt);
%%

ca_signal_neurons_subtracted = zeros(size(roi_neurons_signal));

for i = 1:length(roi_neurons)
    y = roi_neurons_signal(:,i);
    X = ca_signal_doughnuts(:,i);
    
    b = (X'*X)\(X'*y);
    
    y_hat = X * b;
    
    trace = (y - y_hat)/f0(i);
    
    ca_signal_neurons_subtracted(:,i) = trace;
end

ca_signal_neurons_subtracted = timeseries(ca_signal_neurons_subtracted,t,'Name','ca_signal_neurons_subtraced');


end

