function [roi_doughnuts, ca_signal_doughnuts, r_outer] = read(stack,r_outer)
roi_array = stack.load_var('roi_array');
roi_array = calendula.RoI(roi_array);

% Pick out neuron rois. 
neu_idx = ismember({roi_array.group},'NS');
roi_neurons = roi_array(neu_idx);

if nargin < 2
    % Micrometer
    r_outer = ceil(7/stack.dx);
end
r_inner = ceil(2/stack.dx);

se_outer = strel('sphere',r_outer);
se_inner = strel('sphere',r_inner);

roi_doughnuts = calendula.RoI.empty;

for i = 1:length(roi_neurons)
    merged_roi = roi_neurons([roi_neurons ~= roi_neurons(i)]).merge();
    merged_mask = merged_roi.mask;
    merged_mask = imdilate(merged_mask,se_inner);
    
    mask = roi_neurons(i).mask;
    mask_out = imdilate(mask,se_outer);
    mask_in = imdilate(mask,se_inner);
    mask = xor(mask_out,mask_in);
    mask = mask - (mask & merged_mask);
    
    roi_doughnuts(i) = calendula.RoI(mask);
    roi_doughnuts(i).id_connected_roi = roi_neurons(i).id;
    roi_doughnuts(i).channel = roi_neurons(i).channel;
    roi_doughnuts(i).cycle = roi_neurons(i).cycle;
    roi_doughnuts(i).group = 'neuron_doughnut';
end

ca_signal_doughnuts = roi_doughnuts.get_signal(stack);
ca_signal_doughnuts.Name = 'ca_signal_doughnuts';


end

